-- =============================================
-- 名称：分页查询
-- 作者：	邢港
-- 日期：2018/08/15
-- =============================================
CREATE PROCEDURE GetPageData2
  @tableName varchar(100),            --表名
  @pageIndex int=1,                   --第几页
  @pageSize int=10,                   --每页几条记录
  @strOrderBy nvarchar(1000),         --排序，BillDate desc,BillNO desc
  @strColumns nvarchar(1000)='*',     --查询列
  @strWhere nvarchar(1000)='1=1'      --条件
as

begin

declare
  @strTempSql nvarchar(3000),   --临时sql
  @rowCount int,                --记录总数
  @pageCount int,               --页数
  @beginRowid int,              --开始行号
  @endRowid int                 --结束行号

--记录总数
set @strTempSql=N'select @rowCount=count(1) from '+@tableName+' where '+@strWhere
exec sp_executesql @strTempSql,N'@rowCount int output ',@rowCount output 

--处理分页大小
if @pageSize=0
  set @pageSize=@rowCount

--计算总页数
set @pageCount=(@rowCount+@pageSize-1)/@pageSize

--检查当前页数
if @pageIndex<1
begin
  set @pageIndex=1
end
else
begin
  if @pageIndex>@pageCount
  begin
    set @pageIndex=@pageCount
  end
end

--计算rowid范围
set @beginRowid=(@pageIndex-1)*@pageSize+1
set @endRowid=@pageIndex*@pageSize

--取数SQL
set @strTempSql='select '+@strColumns+' from 
  (select ROW_NUMBER() OVER(ORDER BY '+@strOrderBy+') as rowid,* from '+@tableName+' where '+@strWhere+') as t
  where t.rowid between '+str(@beginRowid)+' and '+str(@endRowid)+' order by '+@strOrderBy

exec(@strTempSql)

end
go

grant execute on GetPageData to xjapp
go

